package com.cr.common

import com.cr.data.DEFAULT_STR

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/8/2 10:11
 * 描述：相机模型信息
 */
data class CrCameraInfo(var isConnection: Boolean = false) {
    // define: 2023/8/2 iso
    var iso: String = DEFAULT_STR

    // define: 2023/8/2 快门速度
    var speed: String = DEFAULT_STR

    // define: 2023/8/2 焦距
    var focal: String = DEFAULT_STR

    // define: 2023/8/2 补偿值
    var ev: String = DEFAULT_STR

    // define: 2023/8/2 拍照数量
    var photoCount: String = DEFAULT_STR

    // define: 2023/8/2 视频时长
    var videoTime: String = DEFAULT_STR

    // define: 2023/8/3 相机模式
    var cameraModel: CrCameraMode = CrCameraMode.NON

    /**
     * 模式定义
     */
    enum class CrCameraMode {
        /**
         * 拍照模式
         */
        PHOTO,

        /**
         * 视频模式
         */
        VIDEO,

        /**
         * 未知模式
         */
        NON,
    }
}