package com.cr.common

import android.content.Context
import android.graphics.Typeface
import android.widget.TextView
import com.cr.data.CrUtil

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/3/29 14:33
 * 描述：字体管理器
 */
class CrFontManager {
    companion object{
        /**
         * 设置文本字体
         * @param context Context 上下文
         * @param textView TextView 文本框组件
         * @param textId Int 设置内容
         */
        @JvmStatic
        fun setTextView(context: Context, textView:TextView, textId:Int){
            var typeface:Typeface = Typeface.createFromAsset(context.assets, CrUtil.FontPath)
            textView!!.typeface = typeface
            textView!!.setText(textId)
        }

        /**
         * 设置文本字体
         * @param context Context 上下文
         * @param textView TextView 文本框组件
         * @param text String 设置内容
         */
        @JvmStatic
        fun setTextView(context: Context, textView:TextView, text:String){
            var typeface:Typeface = Typeface.createFromAsset(context.assets, CrUtil.FontPath)
            textView!!.typeface = typeface
            textView!!.text = text
        }

        /**
         * 获取腾讯字体
         * @param context Context 上下文
         * @return Typeface 字体
         */
        fun getTTGBTypeface(context: Context):Typeface{
            return Typeface.createFromAsset(context.assets,"fonts/tx.ttf")
        }
    }
}