package com.cr.common

import com.cr.data.DEFAULT_STR
import dji.v5.common.video.channel.VideoChannelState
import dji.v5.common.video.channel.VideoChannelType
import dji.v5.common.video.decoder.DecoderState
import dji.v5.common.video.stream.StreamSource

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/3/10 09:56
 * 描述：视频通道信息
 */
data class CrVideoChannelInfo (var videoChannelState:VideoChannelState = VideoChannelState.CLOSE){
    // define: 2023/3/10 码流
    var streamSource: StreamSource? = null
    // define: 2023/3/10 视频通道类型
    var videoChannelType: VideoChannelType = VideoChannelType.PRIMARY_STREAM_CHANNEL
    // define: 2023/3/10 视频解码类型
    var decoderState: DecoderState = DecoderState.INITIALIZED
    // define: 2023/3/10 视频分辨率
    var resolution: String = DEFAULT_STR
    // define: 2023/3/10 格式
    var format: String = DEFAULT_STR
    // define: 2023/3/10 帧率
    var fps: Int = -1
    // define: 2023/3/10 比特率
    var bitRate: Int = -1
    var socket: String = DEFAULT_STR
}