package com.cr.event

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/8/14 14:44
 * 描述：地图截屏事件
 */
class EventMapCapture @JvmOverloads constructor(
    action:CaptureAction = CaptureAction.CAPTURE_ACTION_NON,
    joinCaseName:String?=null,
    imageNames:List<String>?= null
) {
    enum class CaptureAction{
        /**
         * 开始截屏
         */
        CAPTURE_ACTION_START,

        /**
         * 截屏完成
         */
        CAPTURE_ACTION_COMPLETE,

        /**
         * 状态未知
         */
        CAPTURE_ACTION_NON
    }
    // define: 2023/8/14 截屏动作
    var action:CaptureAction = CaptureAction.CAPTURE_ACTION_NON
    // define: 2023/8/14 截屏图片名称
    var imageNames:List<String>?=null
    // define: 2023/8/14 关联的案件名称
    var joinCaseName:String?= null

    /**
     * 初始化
     */
    init {
        this.action = action
        this.imageNames = imageNames
        this.joinCaseName = joinCaseName
    }
}