package com.cr.map

import com.cr.pages.FragmentMap

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/6/12 16:37
 * 描述：本地案件面模型
 */
class CaseLocalPolygonModel {
    var name: String? = null // define: 2023/6/12 案件图斑的名称
    var area: String? = null // define: 2023/6/12  案件图斑的面积
    var coords: String? = null // define: 2023/6/12 案件图斑的坐标串
    var type: String? = null // define: 2023/6/12 案件图斑是否已经匹配案件点

    /**
     * 默认初始化
     * @constructor
     */
    constructor(){
        this.name = ""
        this.area = ""
        this.coords = ""
        this.type = FragmentMap.FIELD_CASE_POLYGON_BZ_VALUE_NO
    }

    /**
     * 重写转换为字符串
     * @return String
     */
    override fun toString(): String {
        return "名称:${this.name} 面积:${this.area} 坐标串:${this.coords}"
    }
}