package com.cr.map

import com.esri.arcgisruntime.data.Feature

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/6/12 16:32
 * 描述：地理要素相关模型接口
 */
interface iFeatureModel<T> {
    /**
     * 通过地理要素初始化
     * @param feature Feature 地理要素
     * @return T 初始化
     */
    fun init(feature: Feature):T

    /**
     * 设置属性
     * @param attribute Map<String, String> 属性值
     */
    fun setAttribute(attribute:Map<String,String>)
}