package com.cr.map

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/4/13 15:50
 * 描述：地图图层模型
 */
class LayerModel constructor(){
    // define: 2023/4/13 图层名称
    var name: String? = null

    // define: 2023/4/13 图层
    var layer: Any? = null

    // todo: 2023/4/13 图层是否可见
    var isVisible = false

    // define: 2023/4/13 图层分组名称
    var groupName = ""

    // define: 2023/4/13 图层类型
    var lyrType: LayerType? = null

    // define: 2023/4/13 图层地址
    var url:String? = null

    /**
     * 初始化方法
     * @param name String 图层名称
     * @param isVisible Boolean 图层是否可见
     * @param layerType LayerType 图层类型
     * @param layer Any 图层
     * @constructor
     */
    constructor(name:String,isVisible:Boolean,layerType:LayerType,layer:Any):this(){
        this.name = name
        this.isVisible = isVisible
        this.lyrType = layerType
        this.layer = layer
    }

    /**
     * 初始化方法
     * @param name String 图层名称
     * @param isVisible Boolean 图层是否可见
     * @param url String 图层地址
     * @constructor
     */
    constructor(name:String,isVisible:Boolean,url:String):this(){
        this.name = name
        this.isVisible = isVisible
        this.url = url
    }
}