package com.cr.map

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/4/13 15:31
 * 描述：地图动作
 */
enum class MapAction {
    /**
     * 没有任何动作
     */
    MapTapNon,

    /**
     * 绘制涂鸦
     */
    MapTapDrawDoodle,

    /**
     * 选择涂鸦
     */
    MapTapSelectDoodle,

    /**
     * 微信分享上传动作
     */
    MapTapCaseWxAndUpload,

    /**
     * 添加标志动作
     */
    MapTapAppendMark,

    /**
     * 选择标志动作
     */
    MapTapSelectMark,

    /**
     * 添加违建点动作
     */
    MapTapAddWaypoint,

    /**
     * 选择违建点动作
     */
    MapTapSelectWaypoint,

    /**
     * 删除违建点
     */
    MapTapDeleteWaypoint,

    /**
     * 长度测量动作
     */
    EventSurveyLength,

    /**
     * 面积测量动作
     */
    EventSurveyArea,

    /**
     * 清除测量内容
     */
    EventSurveyClear,

    /**
     * 删除全部案件点动作
     */
    MapTapDeleteAllWaypoing,

    /**
     * 开始移动案件点
     */
    MapTapStartMoveWaypoing,

    /**
     * 移动中动作
     */
    MapTapStopMoveWaypoint,

    /**
     * 创建案件面动作
     */
    EventCaseDrawPolygon,

    /**
     * 保存案件面动作
     */
    EventCaseSavePolygon,

    /**
     * 删除案件面动作
     */
    EventCaseRemovePolygon,

    /**
     * 重置案件绘制动作
     */
    EventCaseDrawReset,

    /**
     * 回退绘制动作
     */
    EventCaseDrawUndo,

    /**
     * 查询网络案件动作
     */
    MapTapQueryNetCase,

    /**
     * 查询本地案件动作
     */
    MapTapQueryLocalCase,

    /**
     * 添加复飞点动作
     */
    MapTapAddRepeatFlight,

    /**
     * 查询位置动作
     */
    MapTapGetLocation,

    /**
     * 清除涂鸦
     */
    EventDoodleClear,

    /**
     * 保存涂鸦
     */
    EventDoodleSave,

    /**
     * 删除全部涂鸦
     */
    EventDoodleRemove,

    /**
     * 移除选择涂鸦
     */
    EventDoodleDelete,

    /**
     * 清除标志
     */
    EventMarkClear,

    /**
     * 保存标志
     */
    EventMarkSave,

    /**
     * 删除全部标志
     */
    EventMarkRemove,

    /**
     * 删除标志
     */
    EventMarkDelete,

    /**
     * 停止草图编辑
     */
    EventStopSketch,

    /**
     * 停止点击
     */
    EventStopTouch,

    /**
     * 输入定位位置到地图
     */
    EventInputLocationToMap,
}