package com.cr.models

import com.cr.common.ClassManager
import org.json.JSONObject

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/9/1 09:38
 * 描述：上传案件模型
 */
class SubmitCaseModel @JvmOverloads constructor(
    userId:String,
) :iNetDataModel<SubmitCaseModel>{
    var userId:String = "" // define: 2023/9/1 上报用户
    var name:String = "" // define: 2023/9/1 案件名称Id
    var longitude:Double = 0.0 // define: 2023/9/1 经度
    var latitude:Double = 0.0 // define: 2023/9/1 纬度
    var altitude:Double = 0.0 // define: 2023/9/1 高度
    var angle:Double = 0.0 // define: 2023/9/1 角度
    var joinPolygon:String = "" // define: 2023/9/1 关联的案件图斑坐标串
    var joinCaseId:String = "" // define: 2023/9/1 关联的案件Id
    var caseDesc:String = "" // define: 2023/9/1 上报描述信息
    var caseType:String = "" // define: 2023/9/1 案件类型
    var caseArea:String = "" // define: 2023/9/1 案件面积
    var submitType:String = "" // define: 2023/9/1 上报类型 add或者upp
    var constructProgress:String = ""  // define: 2023/9/1 建设程度
    var submitImages:String = ""  // define: 2023/9/1 上报照片名称

    /**
     * 初始化
     */
    init {
        this.userId = userId
    }

    /**
     * 转换为JSON字符串
     * @return String
     */
    override fun toJSON(): String {
        var jsonObj: JSONObject = ClassManager.fieldsToJSONObject(this)
        return jsonObj.toString()
    }
}