package com.cr.viewmodel

import dji.v5.common.video.channel.VideoChannelType
import dji.v5.common.video.interfaces.IVideoChannel

/**
 * 操作系统：MAC系统
 * 创建者：王成
 * 创建日期：2023/3/11 16:25
 * 描述：视频通道变化监听
 */
interface CrVideoChannelListener {
    /**
     * 视频通道变化监听
     * @param videoChannel IVideoChannel
     */
    fun initVideoChannel(videoChannel:IVideoChannel)

    /**
     * 更新通道
     * @param channelType VideoChannelType
     */
    fun updateVideoChannelType(channelType:VideoChannelType)
}